<?php
/* ========================================================================================== */

	/* Блок настроек */
	
	$settings['youtube_key'] = 'AIzaSyC24wyizn-h424T__7g1KMwJwBFFMMojqI'; //  API KEY YouTube
	$settings['proxy']       = '';      // Прокси IPv6 HTTPs / SOCKS5 (не обязательно заполнять). Пример заполнения: 216.115.147.25:19306
	$settings['proxy_auth']  = '';		// Логин и пароль для прокси (не обязательно заполнять). Пример заполнения: pupkin:12345
	$settings['api_fora']    = 1;       // 0 - приоритет для прямого парсинга, 1 - приоритет для api

/*
* ============================================================================================
* Автор:    Sistemos.ru
* E-mail:   sistemos-art@yandex.ru
* Telegram: @Sistemos
* Version:  2.1
* ============================================================================================
*/

@error_reporting(E_ALL ^ E_WARNING ^ E_NOTICE);
@ini_set('display_errors', true);
@ini_set('html_errors', true);
@ini_set('error_reporting', E_ALL ^ E_WARNING ^ E_NOTICE);

define('DATALIFEENGINE', true);
define('ROOT_DIR', substr(dirname(__FILE__), 0, -12));
define('ENGINE_DIR', ROOT_DIR . '/engine');
require_once ENGINE_DIR.'/data/config.php';

/*--------------------------------------------------------------------------------------------*/
 
if ( isset($_POST['fname']) and $_POST['fname'] != '' and !substr_count($_POST['fname'], 'http', 'https') ) {	
	
	$query_text = trim( strip_tags ($_POST['fname']) );	
	$mass = (isset($_POST['select']) && $_POST['select'] == "yes") ? true : false;
	// в зависимости от приоритета
	if ($settings['api_fora']) {
		$video_ids = trailerSelectApi ($query_text, $settings, $mass);
		if (!$video_ids) $video_ids = trailerSelectBody ($query_text, $settings, $mass);				
	} else {
		$video_ids = trailerSelectBody ($query_text, $settings, $mass);	
		if (!$video_ids) $video_ids = trailerSelectApi ($query_text, $settings, $mass);		
	}	
	echo $video_ids;
}



// получение трейлера по API (возвращает код в формате "veLMApxaEE8" для ссылки трейлера)
function trailerSelectApi ($query_text, $settings, $mass = false) {
	
	if (!$query_text || !$settings['youtube_key']) return false;

	$query_text = iconv_dle ($query_text);
	$query_text = urlencode ($query_text);
	
	$pars_url = 'https://www.googleapis.com/youtube/v3/search?part=snippet&maxResults=6&q=' . $query_text . '&max-results=6&orderby=relevance&format=5&alt=json&key=' . $settings['youtube_key'];   
	$json = parsCurl($pars_url, $settings['proxy'], $settings['proxy_auth']);	
	$obj = json_decode($json);
	
	if ($mass) {		
		$video_id_arr = array();
		$n = count($obj->items);
		for ($i = 0; $i < $n; $i++) {
			$video_id_arr[] = $obj->{'items'}[$i]->{'id'}->videoId;
		}	
		if (count($video_id_arr) > 0) {
			return json_encode($video_id_arr);
		} else {
			return false;
		} 		
	} else {
		return $obj->{'items'}['0']->{'id'}->videoId;
	} 
}

// парсинг напрямую (в случае, если не удалось получить трейлер через API)
function trailerSelectBody  ($query_text, $settings, $mass = false) {

	if (!$query_text || !$settings['youtube_key']) return false;
	
	$query_text = preg_replace('/\s/', '%20', $query_text);		
	$pars_url = 'http://www.youtube.com/results?search_query=' . $query_text;
	$content = parsCurl($pars_url, $settings['proxy'], $settings['proxy_auth']);
	
	preg_match_all ('/<a\shref="\/watch\?v=(.+?)"\sclass/', $content, $link_trailer_mass);	
	
	$trailer_mass = array();	
	foreach($link_trailer_mass[1] as $k=>$videoid){
		// если не плейлист, то добавляю в массив чистый videoid
		if (!preg_match("#(&amp;list=.*)#", $videoid)) $trailer_mass[] = $videoid;
	}	
	
	if ($mass) {
		if (count($trailer_mass) > 0) {
			return json_encode($trailer_mass);	
		} else {
			return false;
		} 		
	} else {
		return $trailer_mass[0];
	}	
}

// парсинг контента по урлу
function parsCurl ($url, $proxy = false, $proxy_auth = false) 
{
    if ( $curl = curl_init() ) 
	{
        curl_setopt($curl, CURLOPT_URL, $url);
		  if ($proxy) curl_setopt($curl, CURLOPT_PROXY, $proxy);	
		  if ($proxy_auth) curl_setopt($curl, CURLOPT_PROXYUSERPWD, $proxy_auth);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_USERAGENT,"Mozilla/5.0 (Windows; U; Windows NT 5.1; ru-RU; rv:1.7.12) Gecko/".rand(10000000, 30000000)." Firefox/1.0.7");
        curl_setopt($curl, CURLOPT_REFERER, "https://www.youtube.com/");
        curl_setopt($curl, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($curl, CURLOPT_ENCODING, "");
        curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 6);
        curl_setopt($curl, CURLOPT_TIMEOUT, 9);
        curl_setopt($curl, CURLOPT_MAXREDIRS, 10);
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
        $content = curl_exec($curl);
        curl_close($curl);
    } else
        $content = file_get_contents($url);	
	return $content;
}	

// смена кодировки, если не utf-8
function iconv_dle ($val){
	global $config;
	if ( $config['charset'] != "utf-8" ) {
		if( function_exists( 'mb_convert_encoding' ) ) {
			$val = mb_convert_encoding( $val, "UTF-8", $config['charset'] );
		} elseif( function_exists( 'iconv' ) ) {	
			$val = iconv($config['charset'], "UTF-8//IGNORE", $val);	
		}
	}
	return $val;
}

?>
